using FluentValidation;
using CMSMicroservice.Protobuf.Protos.Role;
namespace CMSMicroservice.Protobuf.Validator.Role;

public class UpdateRoleRequestValidator : AbstractValidator<UpdateRoleRequest>
{
    public UpdateRoleRequestValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
        RuleFor(model => model.Name)
            .NotEmpty();
        RuleFor(model => model.Title)
            .NotEmpty();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<UpdateRoleRequest>.CreateWithOptions((UpdateRoleRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
